define(["jquery"], function( jq ) {
	return function( context, metadata ) {
		// declare private members
		var m_Instance = null;
		
		function createPicture() {
			var pictureObject = metadata.parameters.get("picture_file"),
				pictureFileName = pictureObject.fileName,
				pictureWidth = (typeof pictureObject.width !== "undefined")? pictureObject.width: 100,
				pictureHeight = (typeof pictureObject.height !== "undefined")? pictureObject.height: 100,
				caption = metadata.parameters.get("caption"),
				sharedPath = context.stage.getSharedPath(),
				shellObject = jq( context.getElement() ),
				imageObject = jq( document.createElement("img") );

			shellObject.append( imageObject );

			imageObject.attr( "alt", caption );

			if (pictureFileName) {
				imageObject.attr( "src", sharedPath + pictureFileName );
				imageObject.css({"width": pictureWidth, "height": pictureHeight});
				shellObject.css({"width": pictureWidth, "height": pictureHeight});
			}
			else {
				shellObject.text("No picture!");
			}

			imageObject.on("mousemove", {}, function(){context.page.event.trigger(m_Instance, "onShowQuickInfo");});
		}
	
		// revealing public API
		return {
			onLoading : function() {
				m_Instance = this;
				createPicture();
			}
		};
	};
});
